package ${domain}.module.${moduleName}.mpr;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

import ${domain}.module.${moduleName}.ent.${table.getCName()};
import ${domain}.module.${moduleName}.req.${table.getCName()}FindRequest;
import ${domain}.module.${moduleName}.req.${table.getCName()}UpdateRequest;
import ${domain}.frame.auth.Token;

/**
 * ${table.tableName} - ${table.tableComment}
 *
 * @author ${author?default("")}
 * @since ${.now?string["yyyy-MM-dd"]}
 */
@Mapper
public interface ${table.getCName()}Mapper {

    /**
     * 插入
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回数量
     */
    long insert(@Param("request") ${table.getCName()} request, @Param("token") Token token);

    /**
    * 批量插入
    *
    * @param request 请求对象
    * @param token   令牌
    * @return 返回数量
    */
    long insertBatch(@Param("list") List<${table.getCName()}> request, @Param("token") Token token);

    /**
     * 逻辑删除
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回数量
     */
    long delete(@Param("request") ${table.getCName()} request, @Param("token") Token token);

    /**
     * 更新
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回数量
     */
    long update(@Param("request") ${table.getCName()} request, @Param("token") Token token);

    /**
     * 普通查询
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回对象
     */
    List<${table.getCName()}> find(@Param("request") ${table.getCName()} request, @Param("token") Token token);
<#if table.getFind()>

    /**
     * 高级查询
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回对象
     */
    List<${table.getCName()}> find(@Param("request") ${table.getCName()}FindRequest request, @Param("token") Token token);
</#if>
<#if table.getSearch()>

    /**
     * 模糊查询
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回对象
     */
    List<${table.getCName()}> search(@Param("request") ${table.getCName()}SearchRequest request, @Param("token") Token token);
</#if>

    /**
     * 获得对象
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回对象
     */
    ${table.getCName()} get(@Param("request") ${table.getCName()} request, @Param("token") Token token);
}
